////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*------------------------------------------------------------------------------
Tv: RT-edge bZ[WʐM@\ \[Xt@C
: {t@C͑SvWFNg(INtime/NTX/Win)Ŏgp鋤ʃt@CłB
: 2019.08.08 VK쐬
--------------------------------------------------------------------------------*/

#include "../Common/apiMessage.h"
#include "../Common/apiRTCD.h"


/*------------------------------------------------------------------------------
Tv  : [{bNX𐶐
  : pName    [in] [{bNX
        dwLength [in] R[h(bytes)
        dwNum    [in] R[h
        pRtcdInfo [out] 
߂l: Xe[^XR[h
  : 2019.08.08 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeCreateMailbox(const char *pName, DWORD dwLength, DWORD dwNum, RTCDMEMINFO *pRtcdInfo)
{
	return edgeCreateRTCD(pName, RTCD_WRITE_MULTI, dwLength, dwNum, pRtcdInfo);		// RTCD𐶐
}


/*------------------------------------------------------------------------------
Tv  : [{bNX폜
  : pRtcdInfo [in] 
߂l: Xe[^XR[h
  : 2019.08.08 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeDeleteMailbox(RTCDMEMINFO *pRtcdInfo)
{
	return edgeDeleteRTCD(pRtcdInfo);	// RTCD폜
}


/*------------------------------------------------------------------------------
Tv  : [{bNXI[v
  : pName   [in] [{bNX
        dwAccess[in] ANZX[h
        pHandle [out] RTCDnh
߂l: Xe[^XR[h
  : 2019.08.08 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeOpenMailbox(const char *pName, DWORD dwAccess, RTCDHANDLE *pHandle)
{
	return edgeOpenRTCD(pName, dwAccess, pHandle);		// RTCDI[v
}


/*------------------------------------------------------------------------------
Tv  : [{bNXN[Y
  : pHandle [in] RTCDnh
߂l: Xe[^XR[h
  : 2019.08.08 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeCloseMailbox(RTCDHANDLE *pHandle)
{
	return edgeCloseRTCD(pHandle);		// RTCDN[Y
}


/*------------------------------------------------------------------------------
Tv  : [{bNXɃf[^𑗐M
  : pHandle [in] RTCDnh
        pBuffer [in] MbZ[Wobt@
        dwSize  [in] MbZ[WTCY(bytes)
߂l: Xe[^XR[h
  : 2019.08.08 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeSendData(RTCDHANDLE *pHandle, void *pBuffer, DWORD dwSize)
{
	return edgeWriteRTCD(pHandle, pBuffer, dwSize);		// RTCDɃR[h
}
/*------------------------------------------------------------------------------
Tv  : [{bNXɃf[^𑗐M
  : pHandle [in] RTCDnh
		pBuffer1[in] Mwb_[obt@
		dwSize1 [in] Mwb_[obt@TCY(bytes)
		pBuffer2[in] MbZ[Wobt@
		dwSize2 [in] MbZ[WTCY(bytes)
߂l: Xe[^XR[h
  : 2023.03.29 {{  VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeSendData4Mbox(RTCDHANDLE *pHandle, void *pBuffer1, DWORD dwSize1, void *pBuffer2, DWORD dwSize2)
{
	return edgeWriteRTCD4Mbox(pHandle, pBuffer1, dwSize1, pBuffer2, dwSize2);		// RTCDɃR[h
}

/*------------------------------------------------------------------------------
Tv  : [{bNXf[^M
  : pHandle      [in]  RTCDnh
        pBuffer      [in]  MbZ[Wobt@
        dwBufferSize [in]  MbZ[Wobt@TCY(bytes)
        dwTimeout    [in]  ^CAEg(msec)
߂l: Xe[^XR[h
  : 2019.08.08 VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeReceiveData(RTCDHANDLE *pHandle, void *pBuffer, DWORD dwBufferSize, DWORD dwTimeout)
{
	return edgeReadRTCD(pHandle, pBuffer, dwBufferSize, NULL, dwTimeout);	// RTCD烌R[hǂݍ
}
/*------------------------------------------------------------------------------
Tv  : [{bNXf[^M
  : pHandle      [in]  RTCDnh
		pBuffer1     [in]  Mwb_obt@
		dwBufferSize1[in]  Mwb_obt@TCY(bytes)
		pBuffer2     [in]  MbZ[Wobt@
		dwBufferSize2[in]  MbZ[Wobt@TCY(bytes)
		dwTimeout    [in]  ^CAEg(msec)
߂l: Xe[^XR[h
  : 2023.03.29 {{  VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeReceiveData4Mbox(RTCDHANDLE *pHandle, void *pBuffer1, DWORD dwBufferSize1, void *pBuffer2, DWORD dwBufferSize2, DWORD dwTimeout)
{
	return edgeReadRTCD4Mbox(pHandle, pBuffer1, dwBufferSize1, pBuffer2, dwBufferSize2, NULL, dwTimeout);	// RTCD烌R[hǂݍ
}
/*------------------------------------------------------------------------------
Tv  : [{bNX̃nhLmF
  : pHandle      [in]  RTCDnh
߂l: Xe[^XR[h
  : 2023.03.24   VK쐬
--------------------------------------------------------------------------------*/
egRTCD_API int edgeHandleCheck(RTCDHANDLE *pHandle)
{
	return edgeIsRTCDHandle(pHandle);
}