////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*------------------------------------------------------------------------------
Tv: RT-edge RTCD֘A@\API INtimep\[Xt@C
: {t@CɂINtimeɈˑLqĂ܂B
: 2019.08.08 VK쐬
      2019.12.09 RTCDR[hwb_[ oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/

#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include <rt.h>
#include "egRTCD.h"

static RTHANDLE		hRtcdNode = BAD_RTHANDLE;		// RTCDnodẽ[gvZXnh
static LOCATION		hRtcdLoc = BAD_LOCATION;		// RTCDnodẽP[Vnh
static LOCATION		hMyLoc = BAD_LOCATION;			// ̃P[Vnh

BOOLEAN __stdcall RslMain( RTHANDLE hModule,
						DWORD  ul_reason_for_call,  
						LPVOID lpReserved
						)
{
	switch (ul_reason_for_call) {
		case RSL_PROCESS_ATTACH:
		case RSL_THREAD_ATTACH:
		case RSL_THREAD_DETACH:
		case RSL_PROCESS_DETACH:
		break;
	}

	return TRUE;
}


//------------------------------------------------------------------------------
// [J֐
//------------------------------------------------------------------------------
/*****************************************************************************
* FUNCTION:		edge_setNode
* DESCRIPTION:
*   ()RTCD쐬m[ho^
\*****************************************************************************/
uint32_t edge_setNode(const char *Name)
{
	LOCATION hLoc;
	RTHANDLE hRoot;
	RTHANDLE hMem = 0;
	RTHANDLE hMemCatalog = 0;
	WORD		wRet;
	DWORD		dwRet = EDGE_SUCCESS;//߂l
	void *pMem = NULL;	//̃|C^
	NODE_INFO info;		//Nodei[ϐ
	BOOL		bThisRoot = FALSE;		//m[hō쐬邩ۂ
	LOCATION	hLocalMyLoc = BAD_LOCATION;		// P[Vnh

	if (hRtcdNode != BAD_RTHANDLE)
	{
		return EDGE_RTCD_EXIST_ERROR;	// Ɏ擾ς̏ꍇ͖
	}
	if (!GetRtNodeInfo(THIS_LOCATION, &info)) {	// m[h擾
		return BAD_RTHANDLE;
	}
	hMyLoc = info.Location;				// P[VoĂ
	
	hLoc = GetRtNodeLocationByName(Name);					// wm[h̃P[Vnh擾
	if (hLoc != BAD_LOCATION) {
		if (hMyLoc == hLoc)		//m[hǂ`FbN
			bThisRoot = TRUE;
			
		if(bThisRoot) //m[h̎
			hRoot = GetRtThreadHandles(ROOT_PROCESS);
		else
			hRoot = GetRemoteRootRtProcess(hLoc);				// [gvZXnh擾
		if (hRoot != BAD_RTHANDLE) {
			if (bThisRoot) //m[h̎
			{
				// m
				pMem = AllocateRtMemory(1);						//쐬
				if (pMem == NULL)
				{
					//s͏I
					dwRet = EDGE_RTCD_ALLOCATE_ERROR;
					goto failed;
				}
				hMem = CreateRtMemoryHandle(pMem, 1);				//nh쐬
				//hMem = CreateGlobalRtMemoryObject(hLoc, 1, 0);
				if (hMem == BAD_RTHANDLE) {
					dwRet = EDGE_RTCD_ALLOCATE_ERROR;			// mێs
					goto failed;
				}
			}
			else//m[h
			{
				// m
				hMem = CreateGlobalRtMemoryObject(hLoc, 1, 0);
				if (hMem == BAD_RTHANDLE) {
					dwRet = EDGE_RTCD_ALLOCATE_ERROR;			// mێs
					goto failed;
				}
			}
			hMemCatalog = LookupRtHandle(hRoot, EGRTCDNODE, NO_WAIT);		// ̃Ă邩`FbN
			if (hMemCatalog != BAD_RTHANDLE) {
				wRet = GetRtHandleType(hMemCatalog);
				if (bThisRoot)
					DeleteRtReferenceObject(hMemCatalog);							// t@Xnhĉō폜
				if (wRet == INVALID_TYPE) {
					UncatalogRtHandle(hRoot, EGRTCDNODE);					// J^OcĂԂ̂߃AJ^Oďp
				}
			}
			// J^O
			if (TRUE != CatalogRtHandle(hRoot, hMem, EGRTCDNODE)) {
				dwRet = EDGE_RTCD_CATALOG_ERROR;			// J^Os
				goto failed; 
			}
			hRtcdLoc = hLoc;								// P[Vnhێ
			hRtcdNode = hRoot;								// [gvZXnhێ
			return EDGE_SUCCESS;
		}
	}
	else
	{
		dwRet = EDGE_LOCATION_ERROR;
		goto failed;
	}

failed:
	if (pMem)
		FreeRtMemory(pMem);								//t[
	if (hMem)
		DeleteRtMemoryHandle(hMem);						//폜
	return dwRet;
}

/*****************************************************************************
* FUNCTION:		searchRTCD
* DESCRIPTION:
*   ()RTCD̃J^O
\*****************************************************************************/
RTHANDLE searchRTCD(LOCATION hLoc)
{
	RTHANDLE	hRoot = BAD_RTHANDLE;				// [gvZXnh
	RTHANDLE	hMem = BAD_RTHANDLE;				// Lnh
	WORD		wRet;

	if (hMyLoc == hLoc) //m[h
		hRoot = GetRtThreadHandles(ROOT_PROCESS);
	else
		hRoot = GetRemoteRootRtProcess(hLoc);	// w肳ꂽP[Ṽ[gvZX擾
	if (hRoot == BAD_RTHANDLE) {
		if (hMyLoc != hLoc) //m[h lookupŐt@XIuWFNg폜
			DeleteRtReferenceObject(hRoot);
		return BAD_RTHANDLE;
	}

	hMem = LookupRtHandle(hRoot, EGRTCDNODE, NO_WAIT);	// RTCDbNAbv
	if (hMem == BAD_RTHANDLE) {
		if (hMyLoc != hLoc) { //m[h lookupŐt@XIuWFNg폜
			DeleteRtReferenceObject(hRoot);
			DeleteRtReferenceObject(hMem);
		}
		return BAD_RTHANDLE;
	}

	wRet = GetRtHandleType(hMem);			// nh^Cṽ`FbN
	if (wRet != SEGMENT_TYPE) {
		if (hMyLoc != hLoc) { //m[h lookupŐt@XIuWFNg폜
			DeleteRtReferenceObject(hRoot);
			DeleteRtReferenceObject(hMem);
		}
		return BAD_RTHANDLE;
	}
	if (hMyLoc != hLoc) { //m[h lookupŐt@XIuWFNg폜
		DeleteRtReferenceObject(hMem);
	}
	return hRoot;
}

/*****************************************************************************
* FUNCTION:		edge_getRtcdNodeHandle
* DESCRIPTION:
*   ()RTCD݂m[h̃[gvZXnh擾
\*****************************************************************************/
RTHANDLE edge_getRtcdNodeHandle()
{
	LOCATION hLoc;
	RTHANDLE hRoot;
	NODE_INFO info;
	uint16_t sts;

	if (hRtcdNode != BAD_RTHANDLE)
	{
		return hRtcdNode;							// Ɏ擾ςȂI
	}
	if (!GetRtNodeInfo(THIS_LOCATION, &info)) {		// m[h擾
		return BAD_RTHANDLE;
	}
	hMyLoc = info.Location;							// m[hێ
	// find all nodes
	hLoc = GetFirstRtLocation();					// ŏ̃P[V擾
	while (hLoc != BAD_LOCATION) {					// ܂őSẴm[h`FbN
		sts = GetRtNodeStatus(hLoc);		// m[hNԃ`FbN
		if (sts == E_OK)							// OK
		{
			hRoot = searchRTCD(hLoc);				// RTCDJ^O
			if (hRoot != BAD_RTHANDLE) {			// ꍇAnhێ
				hRtcdLoc = hLoc;
				hRtcdNode = hRoot;

				break;								// I
			}
		}
		hLoc = GetNextRtLocation(hLoc);				// ̃P[V擾
	}

	if (hRtcdNode == BAD_RTHANDLE) {				// Ȃꍇ
		if (!GetRtNodeInfo(THIS_LOCATION, &info)) {	// m[hŐ邽߁Am[h擾
			return BAD_RTHANDLE;
		}
		edge_setNode(info.szNodeName);				// RTCDNODE̓o^
	}

	return hRtcdNode;
}
/*****************************************************************************
* FUNCTION:		GetRootRTCD
* DESCRIPTION:
*   ()RTCDm[h̃[gvZXnh擾
\*****************************************************************************/
RTHANDLE GetRootRTCD()
{
	edge_getRtcdNodeHandle();
	return hRtcdNode;
}
/*****************************************************************************
* FUNCTION:		GetLocationRTCD
* DESCRIPTION:
*   ()RTCDm[h̃P[Vnh擾
\*****************************************************************************/
LOCATION GetLocationRTCD()
{
	edge_getRtcdNodeHandle();
	return hRtcdLoc;
}
LOCATION GetMyLocation()
{
	if (hMyLoc == BAD_RTHANDLE)
		edge_getRtcdNodeHandle();
	return hMyLoc;
}

/*------------------------------------------------------------------------------
Tv  : ݎ擾()
  : tv [out] ݎ 1970.01.01̌oߕbA}CNbԂ
߂l: 0:I 0ȊO:ُI
  : 2019.08.02 VK쐬 (x[X͒䂪쐬BIWî܂܎gp)
        2019.12.09 oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/
static int highperformancegettimeofday(struct _timeval64 *tv)
{
	static struct _timeval64 stv;	/* initial timeval */
	static int64_t sct, tick;
	static int initialized = -1;
	int64_t c;

	if (initialized == -1) {
		_gettimeofday64( &stv );
		if (QueryRtPerformanceFrequency((QWORD*)&tick) == 0)
			return -1;	// No high-reso counter
		if (QueryRtPerformanceCounter((QWORD*)&sct) == 0)
			return -1;	// No high-reso counter
		initialized = 0;
	}

	if (!QueryRtPerformanceCounter((QWORD*)&c))
		return -1;
	tv->tv_sec  = stv.tv_sec  + (long long)((c - sct) / tick);
	tv->tv_usec = stv.tv_usec + (long)(((c - sct) % tick) * 1000000 / tick);
	if (tv->tv_usec >= 1000000) {
		tv->tv_sec++;
		tv->tv_usec -= 1000000;
	}
	return 0;
}


//------------------------------------------------------------------------------
// O[o֐
//------------------------------------------------------------------------------

/*------------------------------------------------------------------------------
Tv  : ݎ擾
  : INtimeł̏ꍇAďôgettimeofdayɂĊ擾Ă邽߁A
        {Ԃ9us|܂B2ڈȍ~͖1usƂȂ܂B
  : pTime        [out] ݎ 1970.01.01̌oߕbԂ
        pMillisecond [out] ݎ ~bԂ
        pMicrosecond [out] ݎ }CNbԂ
߂l: Ȃ
  : 2019.08.02 VK쐬
        2019.12.09 oߕb 32bit64bitɕύX
        2019.12.20 ł_gettimeofday64ɕύX(gNo19 WindowsƂĂ̑΍)
--------------------------------------------------------------------------------*/
void GetNowTime(QWORD *pTime, WORD *pMillisecond, WORD *pMicrosecond)
{
	struct _timeval64 tv;
	int ret;

	ret = _gettimeofday64(&tv);	// ݎ擾

	*pTime = tv.tv_sec;
	*pMillisecond = (WORD)(tv.tv_usec/1000);
	*pMicrosecond = (WORD)(tv.tv_usec%1000);
}

/*------------------------------------------------------------------------------
Tv  : ݎ擾
  : INtimeł̏ꍇAďôgettimeofdayɂĊ擾Ă邽߁A
		{Ԃ9us|܂B2ڈȍ~͖1usƂȂ܂B
  : pTime        [out] ݎ 1970.01.01̌oߕbԂ
        pMicrosecond [out] ݎ }CNbԂ
߂l: Ȃ
  : 2020.08.03  u  VK쐬
--------------------------------------------------------------------------------*/
void GetNowTimeVal(QWORD *pTime, DWORD *pMicrosecond)
{
	struct _timeval64 tv;
	int ret;

	ret = _gettimeofday64(&tv);	// ݎ擾
	*pTime = tv.tv_sec;
	*pMicrosecond = tv.tv_usec;
}

/*------------------------------------------------------------------------------
Tv  : RTCD𐶐
  : pName      [in] RTCD
        dwRtcdSize [in] RTCDTCY(bytes)
        dwMode     [in] ݃[h 1:VO[h 2:}`[h
        dwLength   [in] R[h(bytes)
        dwNum      [in] R[h
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
        pMemResult [out] RTCDʏ
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int CreateRTCD(char *pName, DWORD dwRtcdSize, DWORD dwMode, DWORD dwLength, DWORD dwNum, char *pSem1Name, char *pSem2Name, RTCD_MEM_RESULT *pMemResult)
{
	int			result = 0;
	WORD		wRet;
	void		*pMem = NULL;
	LOCATION	hLoc = BAD_LOCATION;		// P[Vnh
	RTHANDLE	hRoot = BAD_RTHANDLE;		// [gvZXnh
	RTHANDLE	hMem = BAD_RTHANDLE;		// Lnh
	RTHANDLE	hSem = BAD_RTHANDLE;		// Z}tHnh(`FbNp)
	RTHANDLE	hLockSem = BAD_RTHANDLE;	// Z}tHnh(rp)
	RTHANDLE	hNotifySem = BAD_RTHANDLE;	// Z}tHnh(ݒʒmp)
	LOCATION	hLocalMyLoc = BAD_LOCATION;		// P[Vnh
	BOOL		bThisRoot = FALSE;
	//--------------------------------------------------------------------
	// RTCDO`FbN
	//--------------------------------------------------------------------
	hLoc = GetLocationRTCD();										// P[Vnh擾
	hRoot = GetRootRTCD();											// [gvZXnh擾
	hLocalMyLoc = GetMyLocation();									// P[V擾
	if (hLocalMyLoc == hLoc)
		bThisRoot = TRUE;
	hMem = LookupRtHandle(hRoot, pName, NO_WAIT);			// RTCDbNAbv
	if (hMem != BAD_RTHANDLE) {
		wRet = GetRtHandleType(hMem);
		if (bThisRoot)
			DeleteRtReferenceObject(hMem);							// t@Xnhĉō폜
		if (wRet == INVALID_TYPE) {
			UncatalogRtHandle(hRoot, pName);				// J^OcĂԂ̂߃AJ^Oďp
		} else if (wRet == SEGMENT_TYPE) {
			return EDGE_RTCD_EXIST_ERROR;							// ɓRTCD݂܂
		} else {
			return EDGE_RTCD_NAME_EXIST_ERROR;						// ɓOgĂ܂
		}
	}

	hSem = LookupRtHandle(hRoot, pSem1Name, NO_WAIT);		// ̔rpZ}tHĂ邩`FbN
	if (hSem != BAD_RTHANDLE) {
		wRet = GetRtHandleType(hSem);
		if (bThisRoot)
			DeleteRtReferenceObject(hSem);							// t@Xnhĉō폜
		if (wRet == INVALID_TYPE) {
			UncatalogRtHandle(hRoot, pSem1Name);			// J^OcĂԂ̂߃AJ^Oďp
		} else if (wRet == SEMAPHORE_TYPE) {
			return EDGE_RTCD_SEMAPHORE1_EXIST_ERROR;				// ɓZ}tH݂܂(rpZ}tH)
		} else {
			return EDGE_RTCD_SEMAPHORE1_NAME_EXIST_ERROR;			// ɓOgĂ܂(rpZ}tH)
		}
	}

	hSem = LookupRtHandle(hRoot, pSem2Name, NO_WAIT);		// ̏ʒmpZ}tHĂ邩`FbN
	if (hSem != BAD_RTHANDLE) {
		wRet = GetRtHandleType(hSem);
		if (bThisRoot)
			DeleteRtReferenceObject(hSem);							// t@Xnhĉō폜
		if (wRet == INVALID_TYPE) {
			UncatalogRtHandle(hRoot, pSem2Name);			// J^OcĂԂ̂߃AJ^Oďp
		} else if (wRet == SEMAPHORE_TYPE) {
			return EDGE_RTCD_SEMAPHORE2_EXIST_ERROR;				// ɓZ}tH݂܂(ʒmpZ}tH)
		} else {
			return EDGE_RTCD_SEMAPHORE2_NAME_EXIST_ERROR;			// ɓOgĂ܂(ʒmpZ}tH)
		}
	}

	//--------------------------------------------------------------------
	// RTCD𐶐
	//--------------------------------------------------------------------
	if (bThisRoot)
	{
		pMem = AllocateRtMemory(dwRtcdSize);						//쐬
		if (pMem == NULL) {
			result = EDGE_RTCD_ALLOCATE_ERROR;							// RTCDmێs
			goto ROLLBACK_2;
		}
		hMem = CreateRtMemoryHandle(pMem, dwRtcdSize);				//nh쐬
		if (hMem == BAD_RTHANDLE) {
			result = EDGE_RTCD_ALLOCATE_ERROR;							// RTCDmێs
			goto ROLLBACK_2;
		}
	}
	else
	{
		hMem = CreateGlobalRtMemoryObject(hLoc, dwRtcdSize, 0);			// wm[hŃm
		if (hMem == BAD_RTHANDLE) {
			result = EDGE_RTCD_ALLOCATE_ERROR;							// RTCDmێs
			goto ROLLBACK_2;
		}
		pMem = MapRtSharedMemory(hMem);						// L}bsO
		if (pMem == NULL) {
			result = EDGE_RTCD_MAPPING_ERROR;							// }bsOs
			goto ROLLBACK_3;
		}
	}

	

	if (CatalogRtHandle(hRoot, hMem, pName) == FALSE) {		// J^O
		result = EDGE_RTCD_CATALOG_ERROR;								// RTCDJ^Os
		goto ROLLBACK_3;
	}

	//--------------------------------------------------------------------
	// Z}tH
	//--------------------------------------------------------------------
	if (bThisRoot)
		hLockSem = CreateRtSemaphore(1, 1, FIFO_QUEUING);		// ʒmpZ}tH
	else
		hLockSem = CreateGlobalRtSemaphore(hLoc, 1, 1, FIFO_QUEUING);		// rpZ}tH
	if (hLockSem == BAD_RTHANDLE ) {									// Z}tHs
		result = EDGE_RTCD_CREATE_SEMAPHORE1_ERROR;
		goto ROLLBACK_4;
	}

	UncatalogRtHandle(hRoot, pSem1Name);						// rpZ}tHAJ^O(J^OcĂꍇ邽)

	if (CatalogRtHandle(hRoot, hLockSem, pSem1Name) == FALSE) {// rpZ}tHJ^O
		result = EDGE_RTCD_CATALOG_SEMAPHORE1_ERROR;
		goto ROLLBACK_5;
	}
	if (bThisRoot)
		hNotifySem = CreateRtSemaphore(0, (ushort)dwNum, FIFO_QUEUING);		// ʒmpZ}tH
	else
		hNotifySem = CreateGlobalRtSemaphore(hLoc, 0, (ushort)dwNum, FIFO_QUEUING);		// ʒmpZ}tH
	if (hNotifySem == BAD_RTHANDLE ) {									// Z}tHs
		result = EDGE_RTCD_CREATE_SEMAPHORE2_ERROR;
		goto ROLLBACK_6;
	}

	UncatalogRtHandle(hRoot, pSem2Name);						// ʒmpZ}tHAJ^O(J^OcĂꍇ邽)

	if (CatalogRtHandle(hRoot, hNotifySem, pSem2Name) == FALSE) {	// ʒmpZ}tHJ^O
		result = EDGE_RTCD_CATALOG_SEMAPHORE2_ERROR;
		goto ROLLBACK_7;
	}

	//--------------------------------------------------------------------
	// [obN
	//--------------------------------------------------------------------
	if (result != 0) {									// rŃG[Ƃ
ROLLBACK_7:
		DeleteRtSemaphore(hNotifySem);			// ʒmpZ}tH폜
ROLLBACK_6:
		UncatalogRtHandle(hRoot, pSem1Name);	// rpZ}tHAJ^O
ROLLBACK_5:
		DeleteRtSemaphore(hLockSem);			// rpZ}tH폜
ROLLBACK_4:
		UncatalogRtHandle(hRoot, pName);		// RTCDAJ^O
ROLLBACK_3:
		if (hMem)
		{
			if(bThisRoot)
				DeleteRtReferenceObject(hMem);					// RTCDnh폜
			else
				DeleteRtMemoryHandle(hMem);						//폜
		}
		
ROLLBACK_2:
		if(pMem)
			FreeRtMemory(pMem);					// RTCD
		return result;									// G[R[hԂ
	}

	//--------------------------------------------------------------------
	// RTCDʏ
	//--------------------------------------------------------------------
	memset(pMemResult, 0, sizeof(RTCD_MEM_RESULT));
	pMemResult->pMem = pMem;							// RTCD|C^
	pMemResult->hMem = (OBJHANDLE)hMem;					// RTCDnh
	pMemResult->hLockSem = (OBJHANDLE)hLockSem;			// Z}tHnh(rp)
	pMemResult->hNotifySem = (OBJHANDLE)hNotifySem;		// Z}tHnh(ݒʒmp)

	return EDGE_SUCCESS;
}


/*------------------------------------------------------------------------------
Tv  : RTCD폜
  : pName      [in] RTCD
        pRtcdInfo  [in] 
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int DeleteRTCD(char *pName, RTCDMEMINFO *pRtcdInfo, char *pSem1Name, char *pSem2Name)
{
	WORD				wRet;
    EDGE_RTCD_HEADER	*pRtcdHeader = NULL;				// RTCDwb_[̃|C^

	pRtcdHeader = (EDGE_RTCD_HEADER*)pRtcdInfo->pRtcd;		// RTCDwb_[̃|C^ɕϊ

	//--------------------------------------------------------------------
	// RTCD폜
	//--------------------------------------------------------------------
	if (UncatalogRtHandle(GetRootRTCD(), pName) == FALSE) {	// RTCDAJ^O
		// Ȃ DeleteRTCDrŎsꍇAȍ~AJ^OG[ƂȂĂ܂
	}

	UncatalogRtHandle(GetRootRTCD(), pSem1Name);				// rpZ}tHAJ^O
	UncatalogRtHandle(GetRootRTCD(), pSem2Name);				// ʒmpZ}tHAJ^O

	wRet = GetRtHandleType((RTHANDLE)pRtcdHeader->lock_sem_handle);					// rpZ}tHnh`FbN
	if (wRet == SEMAPHORE_TYPE) {
		if (DeleteRtSemaphore((RTHANDLE)pRtcdHeader->lock_sem_handle) == FALSE) {		// rpZ}tH폜
			return EDGE_RTCD_DELETE_SEMAPHORE1_ERROR;
		}
	}
	
	wRet = GetRtHandleType((RTHANDLE)pRtcdHeader->notify_sem_handle);					// ʒmpZ}tHnh`FbN
	if (wRet == SEMAPHORE_TYPE) {
		if (DeleteRtSemaphore((RTHANDLE)pRtcdHeader->notify_sem_handle) == FALSE ){	// ʒmpZ}tH폜
			return EDGE_RTCD_DELETE_SEMAPHORE2_ERROR;
		}
	}

	wRet = GetRtHandleType((RTHANDLE)pRtcdHeader->mem_handle);							// RTCDnh`FbN
	if (wRet == SEGMENT_TYPE) {
		if (DeleteRtMemoryHandle((RTHANDLE)pRtcdHeader->mem_handle) == FALSE ){		// RTCDnh폜
			return	EDGE_RTCD_DELETE_MEM_HANDLE_ERROR;											// nh폜G[
		}
	}

	if (FreeRtMemory(pRtcdInfo->pRtcd) == -1) {										// RTCD({)
		return EDGE_RTCD_FREE_ERROR;															// G[
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDI[v
  : pName      [in] RTCD
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
        pMem       [out] RTCD}bsÕ|C^
        pMap       [out] RTCDnh̃|C^
        pSem1      [out] rpZ}tHnh̃|C^
        pSem2      [out] ʒmpZ}tHnh̃|C^
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int OpenRTCD(char *pName, char *pSem1Name, char *pSem2Name, BYTE **pMem, void **pMap, void **pSem1, void **pSem2)
{
	WORD wRet;
	EDGE_RTCD_HEADER *pHeader = NULL;						// RTCDwb_[
	RTHANDLE hRoot = BAD_RTHANDLE;							// [gvZXnh
	RTHANDLE hMem = BAD_RTHANDLE;							// Lnh
	RTHANDLE hSem1 = BAD_RTHANDLE;							// rpZ}tHnh
	RTHANDLE hSem2 = BAD_RTHANDLE;							// ʒmpZ}tHnh
	LOCATION	hLoc = BAD_LOCATION;						// P[Vnh
	LOCATION	hLocalMyLoc = BAD_LOCATION;						// P[Vnh
	BOOL		bThisRoot = FALSE;							// P[Vǂ
	hRoot = GetRootRTCD();									// [gvZXnh擾
	hLoc = GetLocationRTCD();								// P[Vnh擾
	hLocalMyLoc = GetMyLocation();							// P[V擾
	if (hLocalMyLoc == hLoc)
		bThisRoot = TRUE;
	//--------------------------------------------------------------------
	// RTCDI[v
	//--------------------------------------------------------------------
	hMem = LookupRtHandle(hRoot, pName, NO_WAIT);	// LbNAbv
	if (hMem == BAD_RTHANDLE) {
		return EDGE_RTCD_LOOKUP_ERROR;						// bNAbvs
	} else {
		wRet = GetRtHandleType(hMem);
		if (wRet == INVALID_TYPE) {
			UncatalogRtHandle(hRoot, pName);		// J^OcĂԂ̂߃AJ^OăG[Ԃ
			return EDGE_RTCD_NOT_EXIST_ERROR;				// RTCD݂܂
		} else if (wRet == SEGMENT_TYPE) {
															// ̂ߏp
		} else {
			return EDGE_RTCD_NAME_EXIST_ERROR;				// ɓOgĂ܂
		}
	}

	*pMem = (BYTE*)MapRtSharedMemory(hMem);		// L}bsO
	if (*pMem == NULL) {
		return EDGE_RTCD_MAPPING_ERROR;						// }bsOs
	}

	//------------------------------------------------------------------------------------------
	// Z}tHI[v
	//------------------------------------------------------------------------------------------
	hSem1 = LookupRtHandle(hRoot, pSem1Name, NO_WAIT);	// edgeWriteRTCD̒ŔrpZ}tHgp邽߁ArpZ}tH̃nh擾
	if (hSem1 == BAD_RTHANDLE) {                                // edgeCreateRTCDedgeOpenRTCDĂяoꍇ
		return EDGE_RTCD_LOOKUP_SEMAPHORE_ERROR;
	} else {
		wRet = GetRtHandleType(hSem1);
		if (wRet != SEMAPHORE_TYPE) {                           // nhsȏꍇ⓯J^ÕIuWFNgɎgĂꍇ
			if (wRet == INVALID_TYPE) {                         // INtime Explorerɂ(invalid)ɂȂĂꍇBZ}tH폜vZXIꂽꍇ(invalid)ƂȂ
				UncatalogRtHandle(hRoot, pSem1Name);
				return EDGE_RTCD_NOT_EXIST_SEMAPHORE_ERROR;
			} else {                                            // J^ÕIuWFNgɎgĂꍇ
				return EDGE_RTCD_NAME_EXIST_ERROR;
			}
		}
	}

	hSem2 = LookupRtHandle(hRoot, pSem2Name, NO_WAIT);	// edgeReadRTCD/edgeWriteRTCD̒ŏʒmpZ}tHgp邽߁AʒmpZ}tH̃nh擾
	if (hSem2 == BAD_RTHANDLE) {                                // edgeCreateRTCDedgeOpenRTCDĂяoꍇ
		return EDGE_RTCD_LOOKUP_SEMAPHORE_ERROR;
	} else {
		wRet = GetRtHandleType(hSem2);
		if (wRet != SEMAPHORE_TYPE) {                           // nhsȏꍇ⓯J^ÕIuWFNgɎgĂꍇ
			if (wRet == INVALID_TYPE) {                         // INtime Explorerɂ(invalid)ɂȂĂꍇBZ}tH폜vZXIꂽꍇ(invalid)ƂȂ
				UncatalogRtHandle(hRoot, pSem2Name);
				return EDGE_RTCD_NOT_EXIST_SEMAPHORE_ERROR;
			} else {                                            // J^ÕIuWFNgɎgĂꍇ
				return EDGE_RTCD_NAME_EXIST_ERROR;
			}
		}
	}

	//--------------------------------------------------------------------
	// nhԂ
	//--------------------------------------------------------------------
	if(bThisRoot)
		*pMap = NULL;				// RTCDnhԂ(INtimȅꍇ̓t@C}bsOIuWFNgNULLƂ)
	else
		*pMap	= (void**)hMem;				// RTCDnhԂ(INtimȅꍇőm[h̏ꍇ̓t@XIuWFNgɂȂדn)
	*pSem1	= (void**)hSem1;	// rpZ}tHnhԂ
	*pSem2	= (void**)hSem2;	// ʒmpZ}tHnhԂ

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDN[Y
  : pHandle [in] RTCDnh
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int CloseRTCD(RTCDHANDLE *pHandle)
{
	//--------------------------------------------------------------------
	// RTCDN[Y
	//--------------------------------------------------------------------
	if (pHandle->pMem_handle)//̃nhꍇ͊eIuWFNgt@XIuWFNg̈׍폜

	{
		DeleteRtReferenceObject((RTHANDLE)pHandle->pMem_handle);					// RTCDnh폜
		if(pHandle->pSem1_handle)
			DeleteRtReferenceObject((RTHANDLE)pHandle->pSem1_handle);					// Z}tHnh폜
		if (pHandle->pSem2_handle)
			DeleteRtReferenceObject((RTHANDLE)pHandle->pSem2_handle);					// Z}tHnh폜
	}
	if (FreeRtMemory(pHandle->pRtcdHeader) == -1) {	// RTCD({)
		return EDGE_RTCD_FREE_ERROR;							// G[
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDZ}tH擾
  : hSem    [in] Z}tHnhl
        timeout [in] ^CAEgl(msec)
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int WaitRTCDSemaphore(OBJHANDLE hSem, DWORD timeout)
{
	DWORD dwRet;
	DWORD dwErr;

	dwRet = WaitForRtSemaphore((RTHANDLE)hSem, 1, timeout);	// Z}tH擾
	if (dwRet == WAIT_FAILED) {
		dwErr = GetLastRtError();		
		if (dwErr == E_TIME) {
			return EDGE_RTCD_SEMAPHORE_TIMEOUT;							// Z}tH^CAEg
		} else {
			return EDGE_RTCD_WAIT_SEMAPHORE_ERROR;						// Z}tH擾G[	
		}
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDrpZ}tH
  : hSem    [in] Z}tHnhl
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int ReleaseRTCDSemaphore(OBJHANDLE hSem)
{
	if (ReleaseRtSemaphore((RTHANDLE)hSem, 1) == FALSE) {		// Z}tH
		return EDGE_RTCD_RELEASE_SEMAPHORE_ERROR;						// Z}tHG[
	}

	return EDGE_SUCCESS;
}
