////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*------------------------------------------------------------------------------
Tv: RT-edge RTCD֘A@\API O[o֐wb_[t@C(Windows)
: ɂȂ
: 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/

#pragma once
#include <windows.h>
#include "../../eghgapiCommon/edgeAPI_RTCD.h"

#ifdef __cplusplus
extern "C"
{
#endif

// RTCDʏ
typedef struct
{
	BYTE *pMem;				// RTCD|C^
	OBJHANDLE hMem;			// RTCDnh
	OBJHANDLE hLockSem;		// Z}tHnh(rp)
	OBJHANDLE hNotifySem;	// Z}tHnh(ݒʒmp)
} RTCD_MEM_RESULT;

//------------------------------------------------------------------------------
// O[o֐
//------------------------------------------------------------------------------
extern void GetNowTime(unsigned long long *pTime, WORD *pMillisecond, WORD *pMicrosecond);
extern void GetNowTimeVal(unsigned long long *pTime, DWORD *pMicrosecond);

// RTCD֘A
extern int CreateRTCD(char *pName, DWORD dwRtcdSize, DWORD dwMode, DWORD dwLength, DWORD dwNum, char *pSem1Name, char *pSem2Name, RTCD_MEM_RESULT *pMemResult);
extern int DeleteRTCD(char *pName, RTCDMEMINFO *pRtcdInfo, char *pSem1Name, char *pSem2Name);
extern int OpenRTCD(char *pName, char *pSem1Name, char *pSem2Name, BYTE **pMem, void **pMap, void **pSem1, void **pSem2);
extern int CloseRTCD(RTCDHANDLE *pHandle);
extern int WaitRTCDSemaphore(OBJHANDLE hSem, DWORD timeout);
extern int ReleaseRTCDSemaphore(OBJHANDLE hSem);

#ifdef __cplusplus
}
#endif
