﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EgConfig
{
    public class ButtonVisibility
    {
        public bool Create              { get; set; }      = false;    // 新規作成
        public bool CreateNewProject    { get; set; }      = false;    // 新規プロジェクト作成
        public bool CreateNewFile       { get; set; }      = false;    // 新規ファイル作成
        public bool Open                { get; set; }      = false;    // 開く
        public bool OpenProject         { get; set; }      = false;    // プロジェクトを開く
        public bool OpenFile            { get; set; }      = false;    // ファイルを開く
        public bool AddFile             { get; set; }      = false;    // ファイル追加
        public bool AddNewFile          { get; set; }      = false;    // 新しいファイルを追加
        public bool AddExistingFile     { get; set; }      = false;    // 既存のファイルを追加
        public bool SaveAll             { get; set; }      = false;    // ファイルを保存
        public bool Export              { get; set; }      = false;    // エクスポート
        public bool Import              { get; set; }      = false;    // インポート
        public bool Exit                { get; set; }      = false;    // 終了
        public bool AddElement          { get; set; }      = false;    // 追加
        public bool RemoveElement       { get; set; }      = false;    // 削除
        public bool RenameElement       { get; set; }      = false;    // 名前変更
        public bool UpRow               { get; set; }      = false;    // 上へ移動
        public bool DownRow             { get; set; }      = false;    // 下へ移動
        public bool AscSort             { get; set; }      = false;    // 昇順ソート
        public bool DesSort             { get; set; }      = false;    // 降順ソート
        public bool ErrorCheck          { get; set; }      = false;    // エラーチェック
        public bool BootOrder           { get; set; }      = false;    // 起動順序設定
        public bool StartupEditor       { get; set; }      = false;    // 外部エディタ起動
        public bool Setting             { get; set; }      = false;    // 設定
        public bool SettingEditor       { get; set; }      = false;    // 外部エディタの設定
        public bool Version             { get; set; }      = false;    // バージョン

        public ButtonVisibility() { }

        public ButtonVisibility(bool all)
        {
            Create              = all;
            CreateNewProject    = all;
            CreateNewFile       = all;
            Open                = all;
            OpenProject         = all;
            OpenFile            = all;
            AddFile             = all;
            AddNewFile          = all;
            AddExistingFile     = all;
            SaveAll             = all;
            Export              = all;
            Import              = all;
            Exit                = all;
            AddElement          = all;
            RemoveElement       = all;
            RenameElement       = all;
            UpRow               = all;
            DownRow             = all;
            AscSort             = all;
            DesSort             = all;
            ErrorCheck          = all;
            BootOrder           = all;
            StartupEditor       = all;
            Setting             = all;
            SettingEditor       = all;
            Version             = all;
        }
    }
}
