﻿////////////////////////////////////////////////////////////////////////////////////////
/// 機能       :   RT-edge XML編集ツール 設定ファイルのシリアライズ用クラス
/// 作成日     :   2022/02/22
/// 作成者     :   mizuno
/// 
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;

namespace EgConfig
{
    [System.Xml.Serialization.XmlRoot("EgConfig")]
    public class EgConfigXML
    {
        [System.Xml.Serialization.XmlElement("Editor")]
        public Editor Editor;

        public EgConfigXML()
        {
            Editor = new Editor();
        }

    }

    [System.Xml.Serialization.XmlRoot("Editor")]
    public class Editor
    {
        [System.Xml.Serialization.XmlElement("Path")]
        public string Path;

        [System.Xml.Serialization.XmlElement("Args")]
        public string Args;

        public Editor()
        {
            Path = "";
            Args = "";
        }
    }
    
}
