﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace EgConfig
{
    public class ElemCheckMsg
    {
        public string Kind { get; set; }
        public int ErrCode { get; set; }
        public string Filename { get; set; }
        public string ServiceName { get; set; }
        public string Element { get; set; }
        public string Message { get; set; }
        public TreeItem TreeItem { get; set; }

        public ElemCheckMsg(string kind, int errcode, string filename, string servicename, string element, string message)
        {
            Kind = kind;
            ErrCode = errcode;
            Filename = filename;
            ServiceName = servicename;
            Element = element;
            Message = message;
        }

        public ElemCheckMsg(string kind, int errcode, string filename, string servicename, string element, string message, TreeItem treeItem)
        {
            Kind = kind;
            ErrCode = errcode;
            Filename = filename;
            ServiceName = servicename;
            Element = element;
            Message = message;
            TreeItem = treeItem;
        }
    }

    public enum ErrorKind
    {
        Info = 1,
        Error = 2
    }
}
