////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
/*------------------------------------------------------------------------------
Tv: RT-edge RTCD֘A@\API Windowsp\[Xt@C
: {t@CɂWindowsɈˑLqĂ܂B
: 2019.08.08 VK쐬
      2019.12.09 RTCDR[hwb_[ oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/

#include "stdafx.h"
#include "egRTCDwin.h"
#include "../../eghgapiCommon/edgeAPI_RTCD.h"

#if defined(_MSC_VER) || defined(_MSC_EXTENSIONS)
	#define DELTA_EPOCH_IN_MICROSECS  11644473600000000Ui64
#else
	#define DELTA_EPOCH_IN_MICROSECS  11644473600000000ULL
#endif



BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
	case DLL_THREAD_ATTACH:
	case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		break;
	}
	return TRUE;
}


//------------------------------------------------------------------------------
// [J֐
//------------------------------------------------------------------------------

/*------------------------------------------------------------------------------
Tv  : t@CpXt@C(vZX)擾
  : pPath     [in]  t@CpX
        pFileName [out] t@Cobt@
        buffSize  [in]  obt@TCY(bytes)
߂l: t@C̕TCY(bytes)
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
static int GetFileName(char *pPath, char *pFileName, int buffSize)
{
	int		result = 0;
    char	*p;
	char	*pPeriod;

    p = &pPath[0];

	while(p != NULL)
	{
		p = strrchr(p, '\\');
        if( p ) {
            p++;
			pPeriod = strrchr(p, '.');
			if( pPeriod ) {
				result = (int)(pPeriod - p);					// vZXoCg
				strncpy_s(pFileName, buffSize, p, pPeriod - p);	// vZXRs[
			}
			break;
        }
    }

	return result;	// vZXoCgԂ
}


/*------------------------------------------------------------------------------
Tv  : ̃vZX擾
  : pProcessName [out] vZXobt@
        buffSize     [in]  obt@TCY(bytes)
߂l: true: false:s
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
static BOOL GetMyProcessName(char *pProcessName, int buffSize)
{
	DWORD	dwRet;
	TCHAR	szPath[MAX_PATH];
	char	szDrive[4];
	char	szDir[MAX_PATH];
	char	szExt[8];

	memset(szPath, 0, sizeof(szPath));

	dwRet = GetModuleFileName(NULL, szPath, sizeof(szPath));
	if (dwRet == 0) {
		return FALSE;
	}

	memset(pProcessName, 0, buffSize);

	_splitpath_s(szPath, szDrive, sizeof(szDrive), szDir, sizeof(szDir), pProcessName, buffSize, szExt, sizeof(szExt));

	return TRUE;
}


struct timezone
{
	int tz_minuteswest; // minutes W of Greenwich
	int tz_dsttime;     // type of dst correction
};

struct timeval64 {
    long long tv_sec;
    long tv_usec;
};

/*------------------------------------------------------------------------------
Tv  : ݎ擾(Windows)
  : tv [out] ݎ 1970.01.01̌oߕbA}CNbԂ
߂l: 0:I 0ȊO:ُI
  : 2019.08.02 VK쐬
        2019.12.09 oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/
static int gettimeofdayWin(struct timeval64 *tv)
{
	FILETIME			ft;
	unsigned __int64	tmpres = 0;

	if (NULL != tv)
	{
		GetSystemTimePreciseAsFileTime(&ft);

		tmpres |= ft.dwHighDateTime;
		tmpres <<= 32;
		tmpres |= ft.dwLowDateTime;
		tmpres /= 10;								// convert into microseconds

		tmpres -= DELTA_EPOCH_IN_MICROSECS;			// converting file time to unix epoch
		tv->tv_sec = (long long)(tmpres / 1000000UL);
		tv->tv_usec = (long)(tmpres % 1000000UL);
	}

	return 0;
}


//------------------------------------------------------------------------------
// O[o֐
//------------------------------------------------------------------------------

/*------------------------------------------------------------------------------
Tv  : ݎ擾
  : INtimeł̏ꍇAďôgettimeofdayɂĊ擾Ă邽߁A
        {Ԃ9us|܂B2ڈȍ~͖1usƂȂ܂B
  : pTime        [out] ݎ 1970.01.01̌oߕbԂ
        pMillisecond [out] ݎ ~bԂ
        pMicrosecond [out] ݎ }CNbԂ
߂l: Ȃ
  : 2019.08.02 VK쐬
        2019.12.09 oߕb 32bit64bitɕύX
--------------------------------------------------------------------------------*/
void GetNowTime(unsigned long long *pTime, WORD *pMillisecond, WORD *pMicrosecond)
{
	struct timeval64	tv;
	int					ret;

	ret = gettimeofdayWin(&tv);	// ݎ擾

	*pTime = tv.tv_sec;
	*pMillisecond = (WORD)(tv.tv_usec/1000);
	*pMicrosecond = (WORD)(tv.tv_usec%1000);
}

/*------------------------------------------------------------------------------
Tv  : ݎ擾
  : INtimeł̏ꍇAďôgettimeofdayɂĊ擾Ă邽߁A
		{Ԃ9us|܂B2ڈȍ~͖1usƂȂ܂B
  : pTime        [out] ݎ 1970.01.01̌oߕbԂ
		pMicrosecond [out] ݎ }CNbԂ
߂l: Ȃ
  : 2020.08.04  u  VK쐬
--------------------------------------------------------------------------------*/
void GetNowTimeVal(unsigned long long *pTime, DWORD *pMicrosecond)
{
	struct timeval64	tv;
	int					ret;

	ret = gettimeofdayWin(&tv);	// ݎ擾
	*pTime = tv.tv_sec;
	*pMicrosecond = tv.tv_usec;
}

/*------------------------------------------------------------------------------
Tv  : WindowsCxgOɕo͂
  : type     [in] Cxg̎
        category [in] Cxg̕
        eventId  [in] Cxgʎq
        szMsg    [in] CxgOɏo͂镶
߂l: 0:I 0ȊO:ُI
  : 2019.08.02 VK쐬
--------------------------------------------------------------------------------*/
int WriteEventLog(WORD type, WORD category, DWORD eventId, const char *szMsg)
{
	char	szMyProcName[64];
	char	szLog[256];
	HANDLE	hEvent;
	
	if (!GetMyProcessName(szMyProcName, sizeof(szMyProcName))) {	// vZX擾 
		return -1;
	}

	memset(szLog, 0, sizeof(szLog));
	sprintf_s(szLog, sizeof(szLog), "RT-edge.%s", szMyProcName);	// CxgÕ\[X𐶐

	hEvent = RegisterEventSource(NULL, szLog);
	ReportEvent(hEvent, type, category, eventId, NULL, 1, 0, &szMsg, NULL);
	DeregisterEventSource(hEvent);									// CxgOɕo
	return 0;
}

/*------------------------------------------------------------------------------
Tv  : RTCD𐶐
  : pName      [in] RTCD
        dwRtcdSize [in] RTCDTCY(bytes)
        dwMode     [in] ݃[h 1:VO[h 2:}`[h
        dwLength   [in] R[h(bytes)
        dwNum      [in] R[h
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
        pMemResult [out] RTCDʏ
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int CreateRTCD(char *pName, DWORD dwRtcdSize, DWORD dwMode, DWORD dwLength, DWORD dwNum, char *pSem1Name, char *pSem2Name, RTCD_MEM_RESULT *pMemResult)
{
	int		result = 0;
	BYTE	*pMem = NULL;
	HANDLE	hMap = NULL;
	HANDLE	hMapFile = NULL;
	HANDLE	hSem = NULL;		// Z}tHnh(`FbNp)
	HANDLE	hLockSem = NULL;	// Z}tHnh(rp)
	HANDLE	hNotifySem = NULL;	// Z}tHnh(ݒʒmp)
	char	szLog[256];

	//--------------------------------------------------------------------
	// RTCD𐶐
	//--------------------------------------------------------------------
	hMapFile = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, pName);	// RTCDĂ邩`FbN
	if (hMapFile != NULL) {
		CloseHandle(hMapFile);										// }bvꂽ߃IuWFNgN[Y
		return EDGE_RTCD_EXIST_ERROR;								// ɓRTCD݂܂
	}

	hSem = OpenSemaphore(SEMAPHORE_ALL_ACCESS, FALSE, pSem1Name);	// ̔rpZ}tHĂ邩`FbN
	if (hSem != NULL) {
		CloseHandle(hSem);											// }bvꂽ߃IuWFNgN[Y
		return EDGE_RTCD_SEMAPHORE1_EXIST_ERROR;					// ɓZ}tH݂܂(rpZ}tH)
	}

	hSem = OpenSemaphore(SEMAPHORE_ALL_ACCESS, FALSE, pSem2Name);	// ̏ʒmpZ}tHĂ邩`FbN
	if (hSem != NULL) {
		CloseHandle(hSem);											// }bvꂽ߃IuWFNgN[Y
		return EDGE_RTCD_SEMAPHORE2_EXIST_ERROR;					// ɓZ}tH݂܂(ʒmpZ}tH)
	}

	hMap = CreateFileMapping(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE, 0, dwRtcdSize, pName);	// t@C}bsOIuWFNg쐬
	if (hMap == NULL) {
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egCreateRTCD,CreateFileMapping Error=%08x,name=%s,size=%ul", GetLastError(), pName, dwRtcdSize);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);									// WindowsCxgOo

		result = EDGE_RTCD_CREATE_FILEMAPPING_ERROR;											// t@C}bsOG[
		goto ROLLBACK_1;
	}

	pMem = (BYTE*)MapViewOfFile(hMap, FILE_MAP_ALL_ACCESS, 0, 0, 0);							// }bvgt@C}bsO
	if (pMem == NULL) {
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egCreateRTCD,MapViewOfFile Error=%08x,name=%s,size=%ul", GetLastError(), pName, dwRtcdSize);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);									// WindowsCxgOo

		result = EDGE_RTCD_MAP_VIEW_ERROR;														// r[}bvG[
		goto ROLLBACK_2;
	}

	hLockSem = CreateSemaphore(NULL, 1, 1, pSem1Name);											// rpZ}tH
	if (hLockSem == NULL) {
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egCreateRTCD,CreateSemaphore(semLock) Error=%08x %s", GetLastError(), pSem1Name);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);									// WindowsCxgOo

		result = EDGE_RTCD_CREATE_SEMAPHORE1_ERROR;												// Z}tHG[(rpZ}tH)
		goto ROLLBACK_3;
	}

	hNotifySem = CreateSemaphore(NULL, 0, dwNum, pSem2Name);										// ʒmpZ}tH
	if (hNotifySem == NULL) {
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egCreateRTCD,CreateSemaphore(semNotify) Error=%08x %s", GetLastError(), pSem2Name);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);									// WindowsCxgOo

		result = EDGE_RTCD_CREATE_SEMAPHORE2_ERROR;												// Z}tHG[(ʒmpZ}tH)
		goto ROLLBACK_4;
	}

	//--------------------------------------------------------------------
	// [obN
	//--------------------------------------------------------------------
	if (result != 0) {			// rŃG[Ƃ
ROLLBACK_4:
		CloseHandle(hLockSem);	// rpZ}tH폜
ROLLBACK_3:
		UnmapViewOfFile(pMem);	// RTCDA}bv
ROLLBACK_2:
		CloseHandle(hMap);		// RTCDnh폜
ROLLBACK_1:
		return result;			// G[R[hԂ
	}

	//--------------------------------------------------------------------
	// RTCDʏ
	//--------------------------------------------------------------------
	memset(pMemResult, 0, sizeof(RTCD_MEM_RESULT));
	pMemResult->pMem = pMem;							// RTCD|C^
	pMemResult->hMem = (OBJHANDLE)hMap;					// RTCDnh
	pMemResult->hLockSem = (OBJHANDLE)hLockSem;			// Z}tHnh(rp)
	pMemResult->hNotifySem = (OBJHANDLE)hNotifySem;		// Z}tHnh(ݒʒmp)

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCD폜
  : pName      [in] RTCD
        pRtcdInfo  [in] 
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int DeleteRTCD(char *pName, RTCDMEMINFO *pRtcdInfo, char *pSem1Name, char *pSem2Name)
{
    EDGE_RTCD_HEADER	*pRtcdHeader = NULL;			// RTCDwb_[̃|C^

	pRtcdHeader = (EDGE_RTCD_HEADER*)pRtcdInfo->pRtcd;	// RTCDwb_[̃|C^ɕϊ

	//--------------------------------------------------------------------
	// RTCD폜
	//--------------------------------------------------------------------
	if (CloseHandle((HANDLE)pRtcdHeader->lock_sem_handle) == FALSE) {	// rpZ}tHnh폜
		return EDGE_RTCD_DELETE_SEMAPHORE1_ERROR;
	}		

	if (CloseHandle((HANDLE)pRtcdHeader->notify_sem_handle) == FALSE) {	// ʒmpZ}tHnh폜
		return EDGE_RTCD_DELETE_SEMAPHORE2_ERROR;
	}

	if (UnmapViewOfFile(pRtcdInfo->pRtcd) == FALSE) {					// RTCDA}bv
		return EDGE_RTCD_UNMAP_VIEW_ERROR;
	}

	if (CloseHandle((HANDLE)pRtcdInfo->mem_handle) == FALSE) {			// RTCDnh폜
		return	EDGE_RTCD_DELETE_MEM_HANDLE_ERROR;
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDI[v
  : pName      [in] RTCD
        pSem1Name  [in] rpZ}tH
        pSem2Name  [in] ʒmpZ}tH
        pMem       [out] RTCD}bsÕ|C^
        pMap       [out] RTCDnh̃|C^
        pSem1      [out] rpZ}tHnh̃|C^
        pSem2      [out] ʒmpZ}tHnh̃|C^
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int OpenRTCD(char *pName, char *pSem1Name, char *pSem2Name, BYTE **pMem, void **pMap, void **pSem1, void **pSem2)
{
	HANDLE	hMapFile = NULL;	// t@C}bsOIuWFNgnh
	HANDLE	hSem1 = NULL;		// rpZ}tHnh
	HANDLE	hSem2 = NULL;		// ʒmpZ}tHnh
	char	szLog[256];

	//--------------------------------------------------------------------
	// RTCDI[v
	//--------------------------------------------------------------------
	hMapFile = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, pName);			// t@C}bsOIuWFNg쐬
	if (hMapFile == NULL) {
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egOpenRTCD,OpenFileMapping Error=%08x,name=%s", GetLastError(), pName);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);				// WindowsCxgOo
		return EDGE_RTCD_OPEN_FILEMAPPING_ERROR;							// t@C}bsOI[vG[
	}

	*pMem = (BYTE*)MapViewOfFile(hMapFile, FILE_MAP_ALL_ACCESS, 0, 0, 0);	// }bvgt@C}bsO
	if (*pMem == NULL) {
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egOpenRTCD,MapViewOfFile Error=%08x,name=%s", GetLastError(), pName);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);				// WindowsCxgOo

		CloseHandle(hMapFile);												// t@C}bsOIuWFNg폜
		return EDGE_RTCD_MAP_VIEW_ERROR;									// r[}bvG[
	}

	//--------------------------------------------------------------------
	// Z}tHI[v
	//--------------------------------------------------------------------
	hSem1 = OpenSemaphore(SEMAPHORE_ALL_ACCESS, FALSE, pSem1Name);			// edgeWriteRTCD̒ŔrpZ}tHgp邽߁ArpZ}tH̃nh擾
	if (hSem1 == NULL) {													// edgeCreateRTCDedgeOpenRTCDĂяoꍇWindowsCxgO擾
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egOpenRTCD,OpenSemaphore Error=%08x,name=%s", GetLastError(), pSem1Name);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);
		return EDGE_RTCD_OPEN_SEMAPHORE1_ERROR;
	}

	hSem2 = OpenSemaphore(SEMAPHORE_ALL_ACCESS, FALSE, pSem2Name);			// edgeReadRTCD/edgeWriteRTCD̒ŏʒmpZ}tHgp邽߁AʒmpZ}tH̃nh擾
	if (hSem2 == NULL) {													// edgeCreateRTCDedgeOpenRTCDĂяoꍇWindowsCxgO擾
		memset(szLog, 0, sizeof(szLog));
		sprintf_s(szLog, sizeof(szLog), "egOpenRTCD,OpenSemaphore Error=%08x,name=%s", GetLastError(), pSem2Name);
		WriteEventLog(EVENTLOG_INFORMATION_TYPE, 0, 1, szLog);
		return EDGE_RTCD_OPEN_SEMAPHORE2_ERROR;
	}

	//--------------------------------------------------------------------
	// nhԂ
	//--------------------------------------------------------------------
	*pMap = hMapFile;	// t@C}bsOIuWFNgnhԂ
	*pSem1 = hSem1;		// rpZ}tHnhԂ
	*pSem2 = hSem2;		// ʒmpZ}tHnhԂ

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDN[Y
  : pHandle [in] RTCDnh
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int CloseRTCD(RTCDHANDLE *pHandle)
{
	//--------------------------------------------------------------------
	// RTCDN[Y
	//--------------------------------------------------------------------
	if (UnmapViewOfFile(pHandle->pRtcdHeader) == FALSE) {	// RTCDA}bv
		return EDGE_RTCD_UNMAP_VIEW_ERROR;
	}
	CloseHandle(pHandle->pMem_handle);						// RTCDnh폜
	CloseHandle(pHandle->pSem1_handle);						// rpZ}tHnh폜
	CloseHandle(pHandle->pSem2_handle);						// ʒmpZ}tHnh폜

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDZ}tH擾
  : hSem    [in] Z}tHnhl
        timeout [in] ^CAEgl(msec)
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int WaitRTCDSemaphore(OBJHANDLE hSem, DWORD timeout)
{
	DWORD dwRet;

	dwRet = WaitForSingleObject((HANDLE)hSem, timeout);	// Z}tH擾
	if (dwRet != WAIT_OBJECT_0) {
		if (dwRet == WAIT_TIMEOUT) {
			return EDGE_RTCD_SEMAPHORE_TIMEOUT;			// Z}tH擾^CAEg
		} else {
			return EDGE_RTCD_WAIT_SEMAPHORE_ERROR;		// Z}tH擾G[	
		}
	}

	return EDGE_SUCCESS;
}

/*------------------------------------------------------------------------------
Tv  : RTCDrpZ}tH
  : hSem    [in] Z}tHnhl
߂l: Xe[^XR[h
  : 2019.08.21 VK쐬
--------------------------------------------------------------------------------*/
int ReleaseRTCDSemaphore(OBJHANDLE hSem)
{
	long previousCount;

	if (ReleaseSemaphore((HANDLE)hSem, 1, &previousCount) == FALSE) {	// Z}tH
		return EDGE_RTCD_RELEASE_SEMAPHORE_ERROR;						// Z}tHG[
	}

	return EDGE_SUCCESS;
}
