﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Runtime.InteropServices;
namespace RTedge
{
    public static partial class EGDEFINE
    {
        //構造体一覧(string保持用)
        public static int RGMS_PRAMSTRING1L = 2048;
        public struct RGMSPRAMTSTRING1
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 2048)]
            public string stParam;
        }

        public static int RGMS_PRAMSTRING2L = 1024;
        public struct RGMSPRAMTSTRING2
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 1024)]
            public string stParam1;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 1024)]
            public string stParam2;
        }
        public static int RGMS_PRAMSTRING4L = 512;
        public struct RGMSPRAMTSTRING4
        {
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 512)]
            public string stParam1;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 512)]
            public string stParam2;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 512)]
            public string stParam3;
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = 512)]
            public string stParam4;
        }
        //------------------------------------------------------------------------------
        // MailBoxを構成する情報
        //------------------------------------------------------------------------------
        [StructLayout(LayoutKind.Sequential, Pack = 1)]//1バイトアライメントに設定
        [Serializable()]
        public struct EGWMAILBOXINFO
        {
            //メールボックス名
            [MarshalAs(UnmanagedType.ByValTStr, SizeConst = EG_MAX_MAILBOXNAME + 1)]
            public string MailBoxName;
            public UInt32 dwColSize;                   // 1レコード長
            public UInt32 dwRowSize;                   // レコード数
        }
    }
}
