﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Windows.Forms;
using RTedge;
namespace EgBoot
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main()
        {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            //2重起動防止
            if (edge_API.fnBootCheck() == true)
            {
                MainForm form = new MainForm();//Mainの起動(ダイアログは無)
                Application.Run();
            }
            else
            {
                MessageBox.Show("Cannot run more than one instance of EgBoot");
            }
        }
    }
}
