﻿////
/// Copyright(C) 2020 Micronet Co. All Rights Reserved.
//
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using RTedge;
namespace EgTime
{
    static class Program
    {
        /// <summary>
        /// アプリケーションのメイン エントリ ポイントです。
        /// </summary>
        [STAThread]
        static void Main(string[] args)
        {
            bool show = false;
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);
            //2重起動防止
            if (edge_API.fnBootCheck() == true)
            {
                EgTimeForm form = new EgTimeForm();

                // 起動時引数のチェック
                if (args.Length != 0)
                {
                    foreach (string arg in args)
                    {
                        if (arg == "/d")    // フォーム表示する
                            show = true;
                    }
                }

                // ウィンドウフォーム表示するかしないか
                if( show )
                    Application.Run(form);
                else
                    Application.Run();          //←ダイアログ非表示用
            }

        }
    }
}
